Package: revss
Type: Package
Title: Robust Estimation in Very Small Samples
Version: 3.1.0
Date: 2026-03-18
Authors@R: c(person(given = "Avraham", family = "Adler",
    role = c("aut", "cph", "cre"), email = "Avraham.Adler@gmail.com",
    comment = c(ORCID = "0000-0002-3039-0703")))
Description: Implements and enhances the estimation techniques described in
    Rousseeuw & Verboven (2002) <doi:10.1016/S0167-9473(02)00078-6> for the
    location and scale of very small samples.
License: BSD_2_clause + file LICENSE
URL: https://github.com/aadler/revss
BugReports: https://github.com/aadler/revss/issues
Encoding: UTF-8
Suggests: covr, tinytest
NeedsCompilation: yes
Packaged: 2026-03-18 18:31:39 UTC; Parents
Author: Avraham Adler [aut, cph, cre] (ORCID:
    <https://orcid.org/0000-0002-3039-0703>)
Maintainer: Avraham Adler <Avraham.Adler@gmail.com>
Repository: CRAN
Date/Publication: 2026-03-19 08:00:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 01:45:52 UTC; unix
Archs: revss.so.dSYM

Package: revss
Type: Package
Title: Robust Estimation in Very Small Samples
Version: 3.1.0
Date: 2026-03-18
Authors@R: c(person(given = "Avraham", family = "Adler",
    role = c("aut", "cph", "cre"), email = "Avraham.Adler@gmail.com",
    comment = c(ORCID = "0000-0002-3039-0703")))
Description: Implements and enhances the estimation techniques described in
    Rousseeuw & Verboven (2002) <doi:10.1016/S0167-9473(02)00078-6> for the
    location and scale of very small samples.
License: BSD_2_clause + file LICENSE
URL: https://github.com/aadler/revss
BugReports: https://github.com/aadler/revss/issues
Encoding: UTF-8
Suggests: covr, tinytest
NeedsCompilation: yes
Packaged: 2026-03-18 18:31:39 UTC; Parents
Author: Avraham Adler [aut, cph, cre] (ORCID:
    <https://orcid.org/0000-0002-3039-0703>)
Maintainer: Avraham Adler <Avraham.Adler@gmail.com>
Repository: CRAN
Date/Publication: 2026-03-19 08:00:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 21:50:18 UTC; unix
Archs: revss.so.dSYM

---
title: Package revss
---
<!-- badges: start -->
[![](https://www.r-pkg.org/badges/version-last-release/revss)](https://cran.r-project.org/package=revss)
[![](http://cranlogs.r-pkg.org/badges/last-month/revss)](https://cran.r-project.org/package=revss)
[![](https://cranlogs.r-pkg.org/badges/grand-total/revss)](https://cran.r-project.org/package=revss)
[![R-CMD-check](https://github.com/aadler/revss/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/aadler/revss/actions/workflows/R-CMD-check.yaml)
[![codecov](https://codecov.io/gh/aadler/revss/graph/badge.svg?token=HbVHa1SFjv)](https://app.codecov.io/gh/aadler/revss)
[![OpenSSF Best Practices](https://bestpractices.coreinfrastructure.org/projects/5541/badge)](https://bestpractices.coreinfrastructure.org/projects/5541)
<!-- badges: end -->

## Description
**revss** is an `R` package which implements and enhances the estimation
techniques described in [Rousseeuw & Verboven (2002)](https://www.researchgate.net/publication/223864903_Robust_estimation_in_very_small_samples#fullTextFileContent)
for the location and scale of very small samples.

## Citation
If you use the package, please cite it as per
[CITATION](https://CRAN.R-project.org/package=revss/citation.html).

## Acknowledgment
The author is grateful Dr. Peter Rousseeuw for his response to this
[MathExchange](https://math.stackexchange.com/q/2447019) question about the
implementation.

## Roadmap
### Major

 * There are no plans for major changes at current
 
### Minor
 
 * There are no plans for minor changes at current
 
## Contributions
Please see
[CONTRIBUTING.md](https://github.com/aadler/revss/blob/master/CONTRIBUTING.md).

## Security
Please see
[SECURITY.md](https://github.com/aadler/revss/blob/master/SECURITY.md).

# Copyright (c) 2020, Avraham Adler All rights reserved
# SPDX-License-Identifier: BSD-2-Clause

tol <- sqrt(.Machine$double.eps)

# Bias Factors
bnRobScl4 <- 1.3082
bnRobSclL <- 1.1256
bnRobSclKL6 <- 0.9696
bnRobSclKLL <- -0.1851
MdASMd3AA <- 1.4872 # nolint object_name_linter
MdASMd3CR <- 1.495  # nolint object_name_linter

## Generate Test Data
eff_seed <- sample.int(65536, 1)
set.seed(eff_seed)
y <- c(9, 2, 14, 4)
vSmall <- c(0, 1e-7, 1e-5)
factErr <- "must be 'AA' or 'CR'"

## RobScale Tests
psif <- function(x) {
  y <- expm1(pmin.int(x / 0.37394112142347236, 100))
  (y / (y + 2)) ^ 2
}

robScaleTest <- function(x, mi = 80L, tol = NULL) {
  if (is.null(tol)) tol <- sqrt(.Machine$double.eps)
  t <- median(x) # nolint object_overwrite_linter
  s <- revss::madn(x)
  i <- 0
  v <- 2
  while (abs(v - 1) >= tol && (i <= mi)) {
    i <- i + 1
    v <- sqrt(2 * mean(psif((x - t) / s)))
    s <- s * v
  }

  s
}

expect_equal(robScale(y, opts = list(usefctrs = FALSE)), robScaleTest(y),
             tolerance = tol)
expect_equivalent(robScale(y, opts = list(usefctrs = FALSE,
                                          tol = 100 * .Machine$double.eps)),
                  robScaleTest(y, tol = 100 * .Machine$double.eps),
                  tolerance = 100 * .Machine$double.eps)
expect_equal(robScale(y), bnRobScl4 * robScaleTest(y), tolerance = tol)

# Test "minobs" Handling
expect_equal(robScale(y[1:3]), madn(y[1:3]), tolerance = tol)
expect_equal(robScale(c(1e-5, 0, 4)), admn(c(1e-5, 0, 4)), tolerance = tol)
expect_equal(robScale(c(0.0001, 0, 4)), madn(c(0.0001, 0, 4)), tolerance = tol)

# Test Exception Handling
expect_true(is.na(robScale(double(0))))
expect_true(is.na(robScale(c(NA, NA), na.rm = TRUE)))
expect_error(robScale(1:5, opts = list(madfctrs = "ZZ")), factErr)

# Test passing factors which only matters for length(x) < minobs
expect_equal(robScale(y[1:3], opts = list(madfctrs = "AA")),
             robScale(y[1:3]), tolerance = tol)
expect_false(isTRUE(all.equal(robScale(y[1:3], opts = list(madfctrs = "CR")),
                              robScale(y[1:3]), tolerance = tol)))
expect_equal(robScale(y[1:3], opts = list(madfctrs = "CR")),
             robScale(y[1:3]) * MdASMd3CR / MdASMd3AA, tolerance = tol)

# Test other options
expect_equal(robScale(y, opts = list(maxit = 1000L)), robScale(y),
             tolerance = tol)
expect_equal(robScale(vSmall), admn(vSmall), tolerance = tol)
expect_equal(robScale(vSmall, opts = list(implbound = 1e-9)),
             madn(vSmall), tolerance = tol)

# Excel precision probably lacking here.
expect_equal(robScale(c(1e-4, 0, 0, 4), opts = list(usefctrs = FALSE)),
             0.0001015301155129359, tolerance = 1e-7)
expect_equal(robScale(c(1L, 0L, 3L, 5L)),
             robScale(c(1, 0, 3, 5)),
             tolerance = tol)
expect_equal(robScale(3:21),
             robScale(3:21, opts = list(usefctrs = FALSE)) *
               19 / (19 - bnRobSclL), tolerance = tol)

robScaleLocTest <- function(x, loc) {
  x <- x - loc
  s <- 1.4826 * median(abs(x))
  converged <- FALSE
  k <- 0
  while (!converged && k < 80) {
    k <- k + 1
    v <- sqrt(2 * mean((2 * plogis(x / (s * 0.37394112142347236)) - 1) ^ 2))
    converged <- abs(v - 1) <= sqrt(.Machine$double.eps)
    s <- s * v
  }
  return(s)
}

# Test Known Location
expect_equal(robScale(y, loc = 7, opts = list(usefctrs = FALSE)),
             robScaleLocTest(y, loc = 7), tolerance = tol)
expect_equal(robScale(1:3, loc = 3, opts = list(usefctrs = FALSE)),
             robScaleLocTest(1:3, loc = 3), tolerance = tol)
expect_false(isTRUE(all.equal(robScale(1:3, opts = list(usefctrs = FALSE)),
                              robScaleLocTest(1:3, loc = 0))))
z <- rnorm(6) + 1
expect_equal(robScale(z, loc = 1),
             robScale(z, loc = 1, opts = list(usefctrs = FALSE)) * bnRobSclKL6,
             tolerance = tol)
z <- rnorm(12) + 3
expect_equal(robScale(z, loc = 3),
             robScale(z, loc = 3, opts = list(usefctrs = FALSE)) *
               12 / (12 - bnRobSclKLL), tolerance = tol)

# Test Error Trapping
expect_true(is.na(robScale(c(y, NA))))
expect_true(is.na(suppressWarnings(robScale(c(y, "A")))))
expect_equal(robScale(c(y, NA), na.rm = TRUE), robScale(y), tolerance = tol)

message("Seed for robScale test session: ", eff_seed)

# Copyright (c) 2025, Avraham Adler All rights reserved
# SPDX-License-Identifier: BSD-2-Clause

tol <- sqrt(.Machine$double.eps)

## Generate Test Data
eff_seed <- sample.int(65536, 1)
set.seed(eff_seed)
x5 <- runif(5, 0, 100)
t5 <- median(x5)
adm5 <- mean(abs(x5 - t5))
mad5 <- median(abs(x5 - t5))
y <- c(9, 2, 14, 4)
oneValErr <- "There needs to be at least two values for a robust measure."
badCentErr <- "center must be 'median' or 'mean"
factErr <- "must be 'AA' or 'CR'"

# Bias reduction factors:
bnMdADM5 <- 1.0750
bnMdADML <- 0.1786
bnMdADMdCR4 <- 1.363
bnMdADMdCRL <- 0.8
bnMdADMdAA4 <- 1.3606
bnMdADMdAAL <- 0.7852
tstSeq <- 3:21
tstL <- length(tstSeq)
tstLE <- 2 * (tstL %/% 2)
tstM <- mean(tstSeq)

## Median Absolute Deviation from the Median Small Sample
expect_equal(madn(y, factors = "CR"), bnMdADMdCR4 * mad(y), tolerance = tol)
expect_equal(madn(y), bnMdADMdAA4 * mad(y), tolerance = tol)
expect_equal(madn(y, center = "median"),
             madn(y, factors = "AA"),
             tolerance = tol)

z <- runif(12)
expect_equal(madn(z, factors = "CR"), 12 / (12 - bnMdADMdCRL) * mad(z),
             tolerance = tol)
expect_equal(madn(z, factors = "AA"), 11 / (11 - bnMdADMdAAL) * mad(z),
             tolerance = tol)
expect_equal(madn(c(NA, z, NA), na.rm = TRUE), madn(z), tolerance = tol)

## Median Absolute Deviation from the Mean Small Sample
expect_equal(madn(x5, center = "mean", factors = "AA"),
             mad(x5, center = mean(x5)) * bnMdADM5, tolerance = tol)
expect_equal(madn(tstSeq, center = "mean"),
             mad(tstSeq, center = tstM) * tstLE / (tstLE - bnMdADML),
             tolerance = tol)

## Error trapping
expect_true(is.na(madn(c(NA, z, NA))))
expect_true(is.na(suppressWarnings(madn(c(z, "c")))))
expect_error(madn(4), oneValErr)
expect_error(madn(4, center = "mean"), oneValErr)
expect_true(is.na(madn(c(x5, NA), center = "mean")))
expect_true(is.na(suppressWarnings(madn(c(x5, "c"), center = "mean"))))
expect_warning(madn(x5, center = "mean", factors = "CR"),
               "Using Adler's factors")
expect_error(madn(1:5, center = "IQR"), badCentErr)
expect_error(madn(1:5, factors = "ZZ"), factErr)

message("Seed for mad test session: ", eff_seed)

# Copyright (c) 2025, Avraham Adler All rights reserved
# SPDX-License-Identifier: BSD-2-Clause

tol <- sqrt(.Machine$double.eps)

## Generate Test Data
eff_seed <- sample.int(65536, 1)
set.seed(eff_seed)
x5 <- runif(5, 0, 100)
t5 <- median(x5)
adm5 <- mean(abs(x5 - t5))
y <- c(9, 2, 14, 4)
oneValErr <- "There needs to be at least two values for a robust measure."
badCentErr <- "center must be 'median' or 'mean"
lZero <- double(0)

admTest <- function(x, ct, co = NULL) {

  if (is.null(co)) {
    co <- 1.2533141373155001 # sqrt(pi / 2)
  } else {
    co <- as.double(co)
  }

  co * mean(abs(x - ct))
}

# ADM
## Mean Absolute Deviation from the Median
expect_equal(adm(x5), adm5 * sqrt(pi / 2), tolerance = tol)
expect_equal(adm(x5), admTest(x5, t5), tolerance = tol)
expect_equal(adm(c(x5, NA), na.rm = TRUE), adm5 * sqrt(pi / 2), tolerance = tol)
expect_equal(adm(x5, constant = 1), adm5, tolerance = tol)
expect_equal(adm(c(x5, NA), constant = 1, na.rm = TRUE), adm5, tolerance = tol)

## Mean Absolute Deviation from the Mean
expect_equal(adm(x5, center = mean(x5)),
             sqrt(pi / 2) * mean(abs(x5 - mean(x5))),
             tolerance = tol)
expect_equal(adm(x5, center = mean(x5)),
             admTest(x5, mean(x5)),
             tolerance = tol)

## Error Trapping
expect_error(adm(4), oneValErr)
expect_true(is.na(suppressWarnings(adm(c(x5, "c")))))
expect_true(is.na(adm(c(x5, NA))))
expect_true(is.na(adm(c(x5, NA), constant = 1)))
expect_true(is.na(adm(lZero)))
expect_true(is.na(adm(NA, na.rm = TRUE)))
expect_true(is.na(adm(1:5, center = "", na.rm = TRUE)))

# Bias reduction factors:
anMADM5 <- 1.1180
anMADML <- 0.5074
anMADMd5 <- 1.2031
anMADMdL <- 0.7558
tstSeq <- 3:20
tstL <- length(tstSeq)
tstM <- mean(tstSeq)
tstMd <- median(tstSeq)

## Mean Absolute Deviation from the Mean
expect_equal(admn(x5, center = "mean"), adm(x5, center = mean(x5)) * anMADM5,
             tolerance = tol)
expect_equal(admn(tstSeq, center = "mean"),
             adm(tstSeq, center = tstM) * tstL / (tstL - anMADML),
             tolerance = tol)

## Mean Absolute Deviation from the Median
expect_equal(admn(x5, center = "median"),
             adm(x5, center = median(x5)) * anMADMd5, tolerance = tol)
expect_equal(admn(tstSeq),
             adm(tstSeq, center = tstMd) *  tstL / (tstL - anMADMdL),
             tolerance = tol)
expect_equal(admn(3:21), # test odd > even
             adm(3:21, center = median(3:21)) * 18 / (18 - anMADMdL),
             tolerance = tol)

expect_error(admn(4), oneValErr)
expect_equal(admn(c(x5, NA), na.rm = TRUE), admn(x5), tolerance = tol)
expect_true(is.na(admn(c(x5, NA))))
expect_true(is.na(suppressWarnings(admn(c(x5, "c")))))
expect_true(is.na(admn(lZero)))
expect_true(is.na(admn(NA, na.rm = TRUE)))
expect_error(admn(1:5, center = "IQR"), badCentErr)

message("Seed for adm test session: ", eff_seed)

# Copyright (c) 2026, Avraham Adler All rights reserved
# SPDX-License-Identifier: BSD-2-Clause

# This tests the median-of-three calls.
expect_identical(.Call(revss:::median_c, as.double(sample.int(101, 101))), 51)

# Copyright (c) 2020, Avraham Adler All rights reserved
# SPDX-License-Identifier: BSD-2-Clause

tol <- sqrt(.Machine$double.eps)

## Generate Test Data
eff_seed <- sample.int(65536, 1)
set.seed(eff_seed)
x5 <- runif(5, 0, 100)
y <- c(9, 2, 14, 4)
lZero <- double(0)
factErr <- "must be 'AA' or 'CR'"

## RobLoc Tests
robLocTest <- function(x, na.rm = FALSE, tol = sqrt(.Machine$double.eps)) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  if (length(x) <= 3) {
    return(median(x))
  } else {
    obj <- function(x, data) {
      sum((2 * plogis((data - x) / madn(data)) - 1)) ^ 2
    }
    fit <- optimize(f = obj, interval = range(x), data = x, tol = tol)
    return(fit$minimum)
  }
}

robLocScaleTest <- function(x, scale, na.rm = FALSE,
                            tol = sqrt(.Machine$double.eps)) {
  if (na.rm) {
    x <- x[!is.na(x)]
  }
  if (length(x) <= 2) {
    return(median(x))
  } else {
    obj <- function(x, data) {
      sum((2 * plogis((data - x) / scale) - 1)) ^ 2
    }
    fit <- optimize(f = obj, interval = range(x), data = x, tol = tol)
    return(fit$minimum)
  }
}

expect_equal(robLoc(x5), robLocTest(x5), tolerance = tol)
expect_equal(robLoc(x5), robLoc(x5, opts = list(maxit = 100L)), tolerance = tol)
expect_equal(robLoc(x5, opts = list(tol = .Machine$double.eps)),
             robLocTest(x5, .Machine$double.eps), tolerance = tol)
expect_equal(robLoc(c(1, 9, 7)), median(c(1, 9, 7)), tolerance = tol)
expect_equal(robLoc(x5, factors = "AA"), robLoc(x5), tolerance = tol)
expect_false(isTRUE(all.equal(robLoc(x5, factors = "CR"),
                              robLoc(x5), tolerance = tol)))

# Known Scale
expect_equal(robLoc(y, scale = 5), robLocScaleTest(y, scale = 5),
             tolerance = tol)
expect_equal(robLoc(c(1, 8, 12), scale = 5),
             robLocScaleTest(c(1, 8, 12), scale = 5), tolerance = tol)
expect_equal(robLoc(c(1, 8), scale = 5), median(c(1, 8)), tolerance = tol)
expect_false(isTRUE(all.equal(robLoc(c(1, 8, 12), scale = 5),
                              median(c(1, 8, 12)))))

# Integer conversion
expect_equal(robLoc(c(5L, 8L, 19L)), robLoc(c(5, 8, 19)), tolerance = tol)

# RobLoc Error Trapping
expect_true(is.na(robLoc(c(x5, NA))))
expect_true(is.na(suppressWarnings(robLoc(c(x5, "A")))))
expect_equal(robLoc(c(x5, NA), na.rm = TRUE), robLoc(x5), tolerance = tol)
expect_true(is.na(robLoc(lZero)))
expect_true(is.na(robLoc(c(NA, NA), na.rm = TRUE)))
expect_error(robLoc(1:5, factors = "ZZ"), factErr)

message("Seed for robLoc test session: ", eff_seed)
